classification
Title: Fails assertion in winsig.c under VC 8.0
Type: Stage:
Components: Library (Lib) Versions: Python 2.5
process
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: Nosy List: loewis, mwh, timothyfitz, varmaa
Priority: normal Keywords:

Created on 2005-03-21 03:25 by timothyfitz, last changed 2005-11-28 17:36 by loewis. This issue is now closed.

Messages (6)
msg24723 - (view) Author: Timothy Fitz (timothyfitz) Date: 2005-03-21 03:25
In 2.4 and current cvs initsignal in signalmodule.c calls 
PyOS_getsig which calls signal with an invalid signal 
number. Under VC 7.1 (and 7.0, and probably before) 
this would return SIG_ERR however under VC 8.0 (beta) 
this causes an assertion failure. 
msg24724 - (view) Author: Michael Hudson (mwh) (Python committer) Date: 2005-03-27 20:59
Logged In: YES 
user_id=6656

Ew.  My first thought is, is that allowed by ANSI C?  I'd guess it's 
undefined behaviour.  It still seems excessively unfriendly -- have you 
reported this to MS?
msg24725 - (view) Author: Martin v. Löwis (loewis) * (Python committer) Date: 2005-04-01 22:02
Logged In: YES 
user_id=21627

C99 7.14.1.1/p8 specifies

# If the request can  be  honored,  the  signal  function
# returns  the  value  of  func for the most recent successful
# call to signal for the specified signal sig.   Otherwise,  a
# value  of SIG_ERR is returned and a positive value is stored
# in errno.

So it seems to me that VC8 is in error: the request cannot
be "honored", so it should return SIG_ERR. Until/if VC8 is
released with that bug, I would like to take no action here.
When it is released, we still might consider to ignore it until
say, 8.1 comes along and fixes the bug.
msg24726 - (view) Author: Martin v. Löwis (loewis) * (Python committer) Date: 2005-10-12 07:54
Logged In: YES 
user_id=21627

See #1311784 for more discussion of this problem.
msg24727 - (view) Author: Atul Varma (varmaa) Date: 2005-11-18 16:10
Logged In: YES 
user_id=863202

Just wanted to mention that the Visual Studio 2005 products
were officially launched on November 7th, 2005, and this
same problem occurs when compiling the Python 2.4 source
using Visual C++ 2005 Express Edition.
msg24728 - (view) Author: Martin v. Löwis (loewis) * (Python committer) Date: 2005-11-28 17:36
Logged In: YES 
user_id=21627

This is now fixed with patch #1350409.
History
Date User Action Args
2005-03-21 03:25:59timothyfitzcreate